package joo {

/**
 * If in debug mode, load a script from the given URL by writing a script element into the document. This downloads and
 * executes the script immediately after the current script block terminates.
 * <p>This method allows a convenient and more readable notation for <code>loadScript(null, debugUrl)</code>.</p>
 * @param debugUrl the script source URL, relative to <code>baseUrl</code>, to use in debug mode
 *
 * @see joo.loadScript
 * @see joo.baseUrl
 * @see joo.debug
 */
[Native]
public native function loadDebugScript(debugUrl:String):void;
}